;  Filename: ISPRINT.ASM
;  Program.: Clipper Extended Library
;  Authors.: Tom Rettig and Brian Russell, modified by Rick Spence
;  Date....: November 1, 1985
;  Notice..: Placed in the public domain by Tom Rettig Associates.
;            Clipper is a trademark of Nantucket.
;  Notes...: Works for parallel printers only.
;
;
;      ISPRINTER() ::= True if the printer is online and ready
;
   NAME   ISPRINTER

   PUBLIC ISPRINTER

   EXTRN   _RETL:FAR    ; return logical true or false

CODESEG SEGMENT BYTE PUBLIC
         ASSUME CS:CODESEG

;------------------------------------------------------------------------------
;  ISPRINTER()
;  Syntax: ISPRINTER()
;  Return: Logical true if the printer is online and ready, otherwise false

ISPRINTER PROC FAR               ; set up far return

         PUSH     AX
         PUSH     BX
         PUSH     DX
         MOV      AH,2H          ; printer status function
         MOV      DX,0H          ; which printer to check
         INT      17H            ; read printer status

         XOR      BX,BX          ; false
         CMP      AH,90H         ; not busy or selected (90h = 10010000)
         JNE      RET_ISPRINTER  ; return false if other than above
         MOV      BX,1           ; true

RET_ISPRINTER:
         PUSH     BX             ; put return value on the stack
         CALL     _RETL          ; return logical value to Clipper
         POP      BX             ; restore the stack

         POP      DX
         POP      BX
         POP      AX
         RET                     ; return

ISPRINTER ENDP

;-----------------------------------------------------------------------------
CODESEG ENDS
        END
