*********** Version 1  3/17/87  15:30: 3
* Copyright (c) 1987 by Phoenix Systems, Inc.
* Filename: wp.prg
* Author..: Robert V. Hannah III
* Date....:  3/17/87
*
* Function sets keys for use in memos - mimics some WordPerfect commands.
* The following commands are needed for proper operation:
*                       Only the '0' is required.
* At program startup - 
*  do inserttrap with '0', 0, 'X'  - Sets an insert flag to keep
*                                    track of Ins.  Very important.
* When editing the memo -
*  wpedit(tmp, 10, 0, 15, 79, ary) - Perform edit.  All but the last parameter
*                                    mimic memoedit(); the last parm is an
*                                    array of special case exits which can be
*                                    used to control the edit.  The result of
*                                    the special case is pushed on to the
*                                    keyboard as only 1 parm can be returned
*                                    by a function.
*
***********
function wpedit
parameters fld, a, b, c, d, ary
private isproc, ret, tmp, x
public wpstat
isproc   = pcount() = 6       && Special case processing.
ret      = fld
wpstat   = ''

CWPSETRC(a, b, c, d)
if isproc
  tmp = len(ary[1])
  for x = 1 to tmp
    set key asc(substr(ary[1], x, 1)) to wpjudge
  next
endif
do wpkeys with .t.
do while .t.
  ret = memoedit(ret, a, b, c, d, .t.)
  if inkey() != 200     && Used for multiple pass operations (like print).
    exit
  endif
  if isproc .and. ! empty(wpstat)
    if ((! empty(ary[1]) .and. wpstat $ ary[1]) .or. ascan(ary, wpstat, 2) > 0)
      tmp = len(ary[1])
      for x = 1 to tmp
        set key asc(substr(ary[1], x, 1)) to
      next
      return(ret)
    endif
  endif
  do case
  case wpstat = 'PRINT'
    if ! isprinter() && check printer status
      do message with 'ERROR - Printer is not on line'
    else
      memowrit('PRN', hardcr(ret))
    endif
  case wpstat = 'FMT'
    ret = memotran(ret, '', '')
  endcase
enddo
do wpkeys with .f.
if isproc
  tmp = len(ary[1])
  for x = 1 to tmp
    set key asc(substr(ary[1], x, 1)) to
  next
endif
return(ret)

procedure wpkeys
parameters tf
wpkeys_on = tf  && Used in inserttrap to disallow insert mode outside of WP
if wpkeys_on
  set key -19 to wpjudge && Shift-F10 
  set key -16 to wpjudge && Shift-F7
  set key -7  to wpjudge && F8
  set key -6  to wpjudge && F7
  set key -2  to wphelp  && F3
  set key 10  to wpjudge && ^Ret
  set key 23  to wpjudge && ^End
  set key 29  to wpjudge && ^Home
  set key 30  to wpjudge && ^PgDn
  set key 31  to wpjudge && ^PgUp
  set key 127 to wpjudge && ^Backspace
else
  set key -19 to         && Shift-F10
  set key -16 to         && Shift-F7
  set key -7  to         && F8
  set key -6  to         && F7
  set key -2  to         && F3
  set key 10  to         && ^Ret
  set key 23  to         && ^End
  set key 29  to         && ^Home
  set key 30  to         && ^PgDn
  set key 31  to         && ^PgUp
  set key 127 to         && ^Backspace
endif
return

procedure wpjudge
parameters p, l, v
private key, scr, notename, r, c
key = lastkey()
do case
case key = -19 && Shift-F10
  r        = row()
  c        = col()
  notename = space(55)
  @ 2, 0
  @ 2, 0 say 'File to be retrieved:' get notename 
  read
  clear gets
  do case
  case empty(notename) .or. lastkey() = 27
*   Don't do anything.
  case ! file(notename)
    do message with 'ERROR:  Cannot find file ' + trim(notename) + '!'
  case insertmode
    keyboard cleanstr(memoread(notename))
  otherwise
    set key 22 to
    keyboard chr(22) + cleanstr(memoread(notename)) + chr(22) + chr(150)
  endcase
  @ 2, 0
  @ r, c say ''
case key = -16 && Shift-F7
  set key 23 to                  && Unset key 23 as it is both ^End and ^W
  wpstat = 'PRINT'
  keyboard chr(23) + chr(200)
case key = -7  && F8
  keyboard chr(2)                && ^B
case key = -6  && F7
  set key 23 to                  && Unset key 23 as it is both ^End and ^W
  keyboard chr(23)               && ^W
case key = 23  && ^End
  keyboard replicate(chr(20),40) && ^T
case key = 30  && ^PgDn
  save screen to scr
  if insertmode
    keyboard CWPCPGDN(scr, row(), col())
  else
    set key 22 to
    keyboard chr(22) + CWPCPGDN(scr, row(), col()) + chr(22) + chr(150)
  endif
case key = 127 && ^Backspace
  keyboard chr(20)               && ^T
otherwise                        && Any other key including special keys.
  set key 23 to                  && Unset key 23 as it is both ^End and ^W
  wpstat = chr(key)
  keyboard chr(23) + chr(200)
endcase
return

procedure inserttrap
parameters p, l, v
private key
if p = '0'
  set key 22  to inserttrap
  public insertmode, wpkeys_on
  insertmode = .f.
  wpkeys_on  = .f.
  set key 150 to inserttrap
endif
if wpkeys_on
  key = lastkey()
  do case
  case key = 22  && Ins
    insertmode = ! insertmode
    set key 22 to
    keyboard chr(22) + chr(150)
  case key = 150 && Ins passed
    set key 22 to inserttrap
  endcase
endif
return

****************
* Clipper side of help routine.
****************
procedure wphelp
parameters p, l, v
private c, r, ret, scr, x
c = col()
r = row()
x = 0
save screen to scr

call _setctyp with word( 0 )  && Turn the cursor off

do while .t.
  cwphelp( x )

  ret = inkey( 0 )
  do case
  case ret = 27     && Esc
    exit
  case ret = 18     && PgUp
    x = if( x = 0, 3, x - 1 )
  case ret =  3     && PgDn
    x = if( x = 3, 0, x + 1 )
  endcase
enddo

call _setctyp with word( 1 )  && Turn the cursor back on

restore screen from scr
@ r, c say ''
return
