/********** Version 1  3/20/87  8:27:51
* Copyright (c) 1987 by Phoenix Systems, Inc.
* Filename: w.c
* Author..: Robert V. Hannah III
* Date....:  3/20/87
*
* Header file for wpc.c
*
**********/

#ifndef H_WPC
#define H_WPC

int tr, lc, br, rc;     /* Window the memo is in */

#define VIDMODE 0x00449 /* Byte location of current video mode */

#define COLOMEM 0xB8000 /* Screen memory locations for color... */
#define MONOMEM 0xB0000 /* ...and monochrome monitors */

#define NORMVID 0x07    /* Screen attributes */
#define REVVID  0x70

#define SL_HOR  0xc4    /* Single bar printables for box */
#define SL_VER  0xb3
#define SL_UL   0xda
#define SL_UR   0xbf
#define SL_LL   0xc0
#define SL_LR   0xd9

#define HLP_TOP 5       /* Window coordinates for help */
#define HLP_BOT 18
#define HLP_LFT 7
#define HLP_RGT 72

#define NULL    0L

char *fptr = (char *) NULL;   /* Pointer to absolute memory addresses */

struct {
   int top_line;
   int bot_line;
} helppage[] = {
    0,  3,
    4, 14,
   15, 22,
   23, 32
};

char *helpblnk = "                                                                ";

char *helpcmd  = " PgUp, PgDn, or Esc to exit ";

char *help[] = {
      "This editor is designed to emulate some of WordPerfect's func-  ",
      "tionality.  Functions that are emulated are described below.    ",
      "Whenever the function key is preceded by the word 'Shift' or    ",
      "'Ctrl' you are to hold down that key and press the function key.",
      "                   Cursor Movement Keys:                        ",
      "                                                                ",
      "    Arrow keys -- Move one space in the corresponding direction.",
      "          Home -- Go to beginning of line.                      ",
      "           End -- Go to end of line.                            ",
      "          PgUp -- Move up one screen.  If at top screen and you ",
      "                  want to go up, use the up arrow key.          ",
      "          PgDn -- Move down one screen.  If at bottom screen and",
      "                  you want to go down, use the down arrow key.  ",
      "    Ctrl-Left,                                                  ",
      "    Ctrl-Right -- Move one word in the given direction.         ",
      "                   Basic Function Keys:                         ",
      "                                                                ",
      "           Ins -- Toggle Insert mode.                           ",
      "           Del -- Delete character under cursor.                ",
      "     Backspace -- Delete character to the left of the cursor.   ",
      "            F7 -- Save and exit memo.                           ",
      "           Esc -- Abandon memo.  You will be asked the question ",
      "                  'Are you sure (Y/N)'.                         ",
      "                 Additional Function Keys:                      ",
      "                                                                ",
      "      Shift-F7 -- Print memo.                                   ",
      "            F8 -- Reformat memo.                                ",
      "     Shift-F10 -- Input ASCII file to memo.                     ",
      "      Ctrl-Ret -- Page break (not yet implemented).             ",
      "      Ctrl-End -- Delete rest of line.                          ",
      "     Ctrl-PgDn -- Delete rest of screen.                        ",
      "Ctrl-Backspace -- Delete word to the right of cursor.  Also     ",
      "                  deletes any blank space before word.          "
};

#endif
